/* =================================================================================
Nombre del fichero:       FILTRO_1_ORDEN.H                     
                    
Descripcion: Calcular un filtro de primer orden...

lAS FUNCIONES PROTOTIPOS ESTAN: FILTRO_1_ORDEN.c
=====================================================================================
 Historia:
-------------------------------------------------------------------------------------
 11-01-2010	Version 1.20
------------------------------------------------------------------------------*/

typedef struct {  
				int  IN_FIL;   		// Entrada: Seal actual ADC... 
				int  IN_FIL_ant;  	// Entrada: Seal Anterior ADC... 
				float  Coefi_A;   // Coeficiente-A del Filtro Primer-Orden... 
				float  Coefi_B;	// Coeficiente-B del Filtro Primer-Orden...
			  
				int  Out_FIL;   		// Salida del Filtro Actual
				int  Out_FIL_ant;   	// Salida del Filtro Anterior
				int  OutFIL_Max;		// Salida del Filtro Maxima
				int  Out_FIL_Min;		// Salida del Filtro Minima
				  
		 	 	void  (*calc)();	  	// Puntero a la funcion de calculo del Filtro
				 } FILTRO_1_ORDEN;	            

typedef FILTRO_1_ORDEN *FILTRO_1_ORDEN_handle;

/*-----------------------------------------------------------------------------
Default initalizer for the PIDREG3 object.
-----------------------------------------------------------------------------*/                     
#define FILTRO_1_ORDEN_DEFAULTS { 0, \
                           0, \
                           0.01, \
                           0.99, \
                           0, \
                           0, \
                           0, \
                           0, \
                           (void (*)(Uint32))FILTRO_1_ORDEN_calc }

/*------------------------------------------------------------------------------
Prototipos para las funciones en PMP_EOLICA01.C
------------------------------------------------------------------------------*/

void FILTRO_1_ORDEN_calc(FILTRO_1_ORDEN_handle);
