/*
 * SRF_PLL_trifasico_funcionseno.c
 *
 *  Created on: 5/4/2016
 *  Author: Carlos
 *  Es una simulacin, el timer 2 no desborda a 1/19950 s (50,1 us), lo hace a 10000 us, esto es para que de tiempo a ejecutar la
 *  interrupcin. (Cdigo ejecutado en FLASH).
 */

#include "DSP2802x_Device.h"     // DSP2802x Headerfile Include File
#include "GLOBAL_FUNCS.h"
#include "GLOBAL_VARS.h"
#include <stdio.h>
#include <math.h>
#include "IQmathLib.h"
#include "Solar_IQ.h"

_iq24 Va=_IQ(0), Vb=_IQ(0), Vc=_IQ(0);
_iq24 buffer[399];
_iq21 buffer_angu_fase_red[399];
int i=0, i_120, i_240;

SPLL_3ph_SRF_IQ spll1;
ABC_DQ0_POS_IQ abc_dq0_pos1;

main ( ) {
DeviceInit();	// Inicializacin del dispositivo
InitDSP();		// Inicializacion de perifericos
SPLL_3ph_SRF_IQ_init(50,_IQ21((float)(1.0/19950)),&spll1);	//399 muestras por cada seal * 50 seales = 19950
ABC_DQ0_POS_IQ_init(&abc_dq0_pos1);

//	BUCLE
	for(;;)
	{
		asm("          NOP");
	}
}

//	INTERRUPCIN TIMER 2 CADA 50us
interrupt void TC0_Cpu_Timer2_isr(void) {
	Va=_IQ24((float)sin(i*(0.0157473316)));	//(360/399)(pi/180)=0.0157473316
	buffer[i]=Va;
	i_120 = i + 266;		//399-133=266
	i_120 = (i_120 > 398) ? (i_120 - 399) : (i_120); //operador ternario: variable=condicin?verdadero:falso
	Vb = buffer[i_120];
	i_240 = i + 133;		//399-266=133
	i_240 = (i_240 > 398) ? (i_240 - 399) : (i_240); //operador ternario: variable=condicin?verdadero:falso
	Vc = buffer[i_240];
	abc_dq0_pos1.a = _IQmpy(Va,_IQ(0.5));
	abc_dq0_pos1.b = _IQmpy(Vb,_IQ(0.5));
	abc_dq0_pos1.c = _IQmpy(Vc,_IQ(0.5));
	abc_dq0_pos1.sin=_IQsin((spll1.theta[1])<<3);// Q24 to Q21
	abc_dq0_pos1.cos=_IQcos((spll1.theta[1])<<3);// Q24 to Q21
	ABC_DQ0_POS_IQ_MACRO(abc_dq0_pos1);
	// Q24 to Q21:
	spll1.v_q[0] = (int32)(_IQtoIQ21(abc_dq0_pos1.q));
	// SPLL call:
	SPLL_3ph_SRF_IQ_FUNC(&spll1);
	//Visualizar ngulo de fase de la red:
	buffer_angu_fase_red[i]=spll1.theta[0];
	i = (i==398) ? 0 : (i+1);
	////////////////////////////////////////////
	CpuTimer2Regs.TCR.bit.TIF = 1;	// clear flag
	VTimer2++;
}

// 	INTERRUPCIN TIMER 1 CADA 1ms
interrupt void TB0_Cpu_Timer1_isr(void){
	CpuTimer1Regs.TCR.bit.TIF = 1;	// Borrar Flag
	VTimer1++;
}

// 	INTERRUPCIN TIMER 0 CADA 100ms
interrupt void TA0_Cpu_Timer0_isr(void){
	VTimer0++;
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;
}

void InitDSP(){
	// Deshabilitamos las interrupciones de la CPU:
   	DINT;
	// Deshabilitamos las interrupciones de la CPU y borramos los flags:
   	IER = 0x0000;
   	IFR = 0x0000;
	InitTimers();	// Inicializacin de los temporizadores
	//InitAdc();	// Inicializacin del conversor analgico - digital
	//InitPWM();	// Inicializacion del mdulo PWM 1 y 2
	//InitSci();	// Inicializamos el modulo SCI
	InitInt();		// Inicializacin de las interrupciones
}

void InitTimers (void){
	EALLOW;
	SysCtrlRegs.PCLKCR3.bit.CPUTIMER0ENCLK = 1; // Habilita el reloj del  Timer-0 de la CPU
   	SysCtrlRegs.PCLKCR3.bit.CPUTIMER1ENCLK = 1; // Habilita el reloj del  Timer-1 de la CPU
 	SysCtrlRegs.PCLKCR3.bit.CPUTIMER2ENCLK = 1; // Habilita el reloj del  Timer-2 de la CPU
   	EDIS;
	// Asignamos los manejadores de interrupcin a los timers:
	EALLOW;
	PieVectTable.TINT0 = &TA0_Cpu_Timer0_isr;
	PieVectTable.TINT1 = &TB0_Cpu_Timer1_isr;
	PieVectTable.TINT2 = &TC0_Cpu_Timer2_isr;
	EDIS;
	// Inicializamos los perifericos de los temporizadores:
   	InitCpuTimers();   // For this example, only initialize the Cpu Timers
	// Configuramos los temporiuzadores, unidades en us
	ConfigCpuTimer(&CpuTimer0, 60, 100000000);	//100ms
	ConfigCpuTimer(&CpuTimer1, 60, 100000000);	//1ms
	ConfigCpuTimer(&CpuTimer2, 60, 10000);		//desborda cada 10000 us,parametro1:frecuen cpu,parametro2:desbor(us)
  	CpuTimer0Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0, Timmer0: run, Habilitado interrupcin por timmer0
   	CpuTimer1Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0, Timmer1: run, Habilitado interrupcin por timmer1
   	CpuTimer2Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0, Timmer2: run, Habilitado interrupcin por timmer2
	/*************************************************************************************/
	VTimer0 = 0;	// Contador del Evento del Timer-0
	VTimer1 = 0; 	// Contador del Evento del Timer-1
	VTimer2 = 0; 	// Contador del Evento del Timer-2
}

void InitInt(void){
	// Configuracin de la interrupcin externa
	/*EALLOW;
		GpioCtrlRegs.GPAMUX2.bit.GPIO18 = 0;         // GPIO-18
		GpioCtrlRegs.GPADIR.bit.GPIO18 = 0;
		GpioCtrlRegs.GPAQSEL2.bit.GPIO18 = 2;
		GpioCtrlRegs.GPAPUD.bit.GPIO18 = 0;
		GpioCtrlRegs.GPACTRL.bit.QUALPRD2 = 0x2F;
	  	GpioCtrlRegs.GPAMUX1.bit.GPIO12 = 0;         // GPIO-12
	   	GpioCtrlRegs.GPADIR.bit.GPIO12 = 0;
	   	GpioCtrlRegs.GPAQSEL1.bit.GPIO12 = 2;
	   	GpioCtrlRegs.GPAPUD.bit.GPIO12 = 1; 	// Para pruebas como se ha utilizado el pulsador, se deshabilita la resistencia de PU
	   	GpioCtrlRegs.GPACTRL.bit.QUALPRD1 = 0x2F;
	   	GpioIntRegs.GPIOXINT1SEL.bit.GPIOSEL = 18;   // XINT1 es GPIO18
		//GpioIntRegs.GPIOXINT1SEL.bit.GPIOSEL = 12; // XINT1 es GPIO12
	EDIS;
	XIntruptRegs.XINT1CR.bit.POLARITY = 1;      	// Flanco SUBIDA de XINT1
	XIntruptRegs.XINT1CR.bit.ENABLE = 1;        	// Enable Xint1
	EALLOW;
	PieVectTable.XINT1 = &xint1_isr;				// Interrupcion XINT1
	EDIS;*/
	// Enable Peripheral, global Ints and higher priority real-time debug events:
   	IER |= (M_INT1|M_INT2);
   	IER |= (M_INT3|M_INT4);
   	IER |= M_INT8;
   	IER |= M_INT9; 							// Esta deja Bloqueado al HW...
	// Activar interrupcin XINT1
	//PieCtrlRegs.PIEIER1.bit.INTx4 = 1;   	// XINT1
	// Activar interrupcin sci fifo rx
	//PieCtrlRegs.PIEIER9.bit.INTx1 = 1;   	// RX SCIA
	// Activar interrupciones ePWM
	//PieCtrlRegs.PIEIER3.bit.INTx1 = 1;	//	ePWM1
	//PieCtrlRegs.PIEIER3.bit.INTx2 = 1;	//	ePWM2
	// Activar Interrupciones Timers-CPU:
	PieCtrlRegs.PIEIER1.bit.INTx7 = 1; 	//	T0
   	IER |= (M_INT13 |M_INT14) ;			//	T1 y T2
   	//////////////////////////////////////////////////////////
	// Enable the PIE
    PieCtrlRegs.PIECTRL.bit.ENPIE = 1;
	// Enables PIE to drive a pulse into the CPU
	PieCtrlRegs.PIEACK.all = 0xFFFF;
	// Enable Interrupts at the CPU level:
    EINT;   // Enable Global interrupt INTM
	ERTM;   // Enable Global realtime interrupt DBGM
	//////////////////////////////////////////////////////
}














