/*
 * spll_1ph_solar_funcionseno.c
 *
 *  Created on: 2/4/2016
 *      Author: usuario
 *
 * Notas:
 * 1) Funcionamiento: Para ver su funcionamiento graficar el buffer de entrada buffer_q24 y buffer de salida buffer_salida_q21.
 * 2)Para visualizar la frecuencia de red hay que ver el archivo spll1.wn en q21 que marcara 314.0 en rad/s,
 * para pasar a hz hay que multiplicar por 0.159155 para obtener 49.97467.
 */




#include "DSP2802x_Device.h"     // DSP2802x Headerfile Include File
#include "GLOBAL_FUNCS.h"
#include "GLOBAL_VARS.h"
#include <stdio.h>
#include <math.h>
#include "IQmathLib.h"
#include "Solar_IQ.h"


_iq24 Va=_IQ(0), buffer_q24[100];
_iq21  buffer_salida_q21[100], frecu_red, frecu_salida;



int i=0, k=0;

SPLL_1ph_IQ spll1;
SPLL_1ph_IQ_NOTCH_COEFF spll_notch_coef1;




main ( ) {

DeviceInit();	// Inicializacin del dispositivo
InitDSP();		// Inicializacion de perifericos



SPLL_1ph_IQ_init(50,_IQ21((float)(1.0/20000)),&spll1);
SPLL_1ph_IQ_notch_coeff_update(((float)(1.0/20000)),(float)(2*3.14151*50*2),(float)0.00001,(float)0.1,&spll1);




//	BUCLE
	for(;;)
	{
		asm("          NOP");

	}
}





//	INTERRUPCIN TIMER 2 CADA 50us
interrupt void TC0_Cpu_Timer2_isr(void) {

	// Realizar accion de Control.....

	Va=_IQ24((float)sin(k*(0.01570796327)));	//(360/400)(pi/180)=0.01570796327

	spll1.AC_input =(long)(Va>>3);		//Va que est en iq_24 es cambiado a iq_21 en spll1.AC_input

	SPLL_1ph_IQ_FUNC(&spll1);

	if (k%4==0) {
	buffer_q24[i]=Va;
	buffer_salida_q21[i]= spll1.sin[0];
	frecu_red=spll1.wn*(0.159155);			//frecuencia de red en hz
	frecu_salida=spll1.wo*(0.159155);

	i = (i==99) ? 0 : (i+1);

	}
	if (k++ > 400) k=0;

	////////////////////////////////////////////
	CpuTimer2Regs.TCR.bit.TIF = 1;	// clear flag
	VTimer2++;

}



// 	INTERRUPCIN TIMER 1 CADA 1ms
interrupt void TB0_Cpu_Timer1_isr(void){

	CpuTimer1Regs.TCR.bit.TIF = 1;	// Borrar Flag
	VTimer1++;

}

// 	INTERRUPCIN TIMER 0 CADA 100ms
interrupt void TA0_Cpu_Timer0_isr(void){


	VTimer0++;
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;
}

void InitDSP(){

	// Deshabilitamos las interrupciones de la CPU
   	DINT;
	// Deshabilitamos las interrupciones de la CPU y borramos los flags
   	IER = 0x0000;
   	IFR = 0x0000;

	InitTimers();	// Inicializacin de los temporizadores

	//InitAdc();	// Inicializacin del conversor analgico - digital
	//InitPWM();	// Inicializacion del mdulo PWM 1 y 2

	//InitSci();	// Inicializamos el modulo SCI

	InitInt();	// Inicializacin de las interrupciones
}

void InitTimers (void){

	EALLOW;
		SysCtrlRegs.PCLKCR3.bit.CPUTIMER0ENCLK = 1; // Habilita el reloj del  Timer-0 de la CPU
   		SysCtrlRegs.PCLKCR3.bit.CPUTIMER1ENCLK = 1; // Habilita el reloj del  Timer-1 de la CPU
   		SysCtrlRegs.PCLKCR3.bit.CPUTIMER2ENCLK = 1; // Habilita el reloj del  Timer-2 de la CPU
   	EDIS;

	// Asignamos los manejadores de interrupcin a los timers
	EALLOW;
	   	PieVectTable.TINT0 = &TA0_Cpu_Timer0_isr;
		PieVectTable.TINT1 = &TB0_Cpu_Timer1_isr;
		PieVectTable.TINT2 = &TC0_Cpu_Timer2_isr;
	EDIS;

	// Inicializamos los perifericos de los temporizadores
   	InitCpuTimers();   // For this example, only initialize the Cpu Timers

	// Configuramos los temporiuzadores, unidades en us
	ConfigCpuTimer(&CpuTimer0, 60, 100000000);		//100ms
	ConfigCpuTimer(&CpuTimer1, 60, 100000000);		//1ms
	ConfigCpuTimer(&CpuTimer2, 60, 50);				//desborda cada 50 us,parametro1:frecuen cpu,parametro2:desbor(us)


  	CpuTimer0Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0, Timmer0: run, Habilitado interrupcin por timmer0
   	CpuTimer1Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0, Timmer1: run, Habilitado interrupcin por timmer1
   	CpuTimer2Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0, Timmer2: run, Habilitado interrupcin por timmer2


	/*************************************************************************************/

	VTimer0 = 0;	// Contador del Evento del Timer-0
	VTimer1 = 0; 	// Contador del Evento del Timer-1
	VTimer2 = 0; 	// Contador del Evento del Timer-2
}

void InitInt(void){

	// Configuracin de la interrupcin externa

	/*EALLOW;

		GpioCtrlRegs.GPAMUX2.bit.GPIO18 = 0;         // GPIO-18
		GpioCtrlRegs.GPADIR.bit.GPIO18 = 0;
		GpioCtrlRegs.GPAQSEL2.bit.GPIO18 = 2;
		GpioCtrlRegs.GPAPUD.bit.GPIO18 = 0;
		GpioCtrlRegs.GPACTRL.bit.QUALPRD2 = 0x2F;

	  	GpioCtrlRegs.GPAMUX1.bit.GPIO12 = 0;         // GPIO-12
	   	GpioCtrlRegs.GPADIR.bit.GPIO12 = 0;
	   	GpioCtrlRegs.GPAQSEL1.bit.GPIO12 = 2;
	   	GpioCtrlRegs.GPAPUD.bit.GPIO12 = 1; 	// Para pruebas como se ha utilizado el pulsador, se deshabilita la resistencia de PU
	   	GpioCtrlRegs.GPACTRL.bit.QUALPRD1 = 0x2F;

	   	GpioIntRegs.GPIOXINT1SEL.bit.GPIOSEL = 18;   // XINT1 es GPIO18
		//GpioIntRegs.GPIOXINT1SEL.bit.GPIOSEL = 12;   // XINT1 es GPIO12

	EDIS;
	XIntruptRegs.XINT1CR.bit.POLARITY = 1;      // Flanco SUBIDA de XINT1
	XIntruptRegs.XINT1CR.bit.ENABLE = 1;        // Enable Xint1

	EALLOW;
		PieVectTable.XINT1 = &xint1_isr;	// Interrupcion XINT1
	EDIS;*/
	// Enable Peripheral, global Ints and higher priority real-time debug events:
   	IER |= (M_INT1|M_INT2);
   	IER |= (M_INT3|M_INT4);

   	IER |= M_INT8;
   	IER |= M_INT9; // Esta deja Bloqueado al HW...

	// Activar interrupcin XINT1
	//PieCtrlRegs.PIEIER1.bit.INTx4 = 1;   // XINT1

	// Activar interrupcin sci fifo rx
	//PieCtrlRegs.PIEIER9.bit.INTx1 = 1;   // RX SCIA

	// Activar interrupciones ePWM
	//PieCtrlRegs.PIEIER3.bit.INTx1 = 1;	//	ePWM1
	//PieCtrlRegs.PIEIER3.bit.INTx2 = 1;	//	ePWM2

	// Activar Interrupciones Timers-CPU
	PieCtrlRegs.PIEIER1.bit.INTx7 = 1; 	//	T0
   	IER |= (M_INT13 |M_INT14) ;			//	T1 y T2
   	//////////////////////////////////////////////////////////
	// Enable the PIE
    PieCtrlRegs.PIECTRL.bit.ENPIE = 1;

	// Enables PIE to drive a pulse into the CPU
	PieCtrlRegs.PIEACK.all = 0xFFFF;

	// Enable Interrupts at the CPU level
    EINT;   // Enable Global interrupt INTM
	ERTM;   // Enable Global realtime interrupt DBGM
	//////////////////////////////////////////////////////

}

void setup_adc(void){

	// Configure ADC
	EALLOW;
	AdcRegs.ADCCTL1.bit.INTPULSEPOS	= 1;	//ADCINT1 trips after AdcResults latch
	AdcRegs.INTSEL1N2.bit.INT1E     = 1;	//habilita interrupcin ADC1
	AdcRegs.INTSEL1N2.bit.INT1CONT  = 0;	//Habilita ADCINT1 Continuous mode
	AdcRegs.INTSEL1N2.bit.INT1SEL	= 1;	//setup EOC1 to trigger ADCINT1 to fire
	AdcRegs.ADCSOC0CTL.bit.CHSEL 	= 0;	//set SOC0 channel select to ADCINA0
	//AdcRegs.ADCSOC1CTL.bit.CHSEL 	= 1;	//set SOC1 channel select to ADCINA1
	//AdcRegs.ADCSOC2CTL.bit.CHSEL 	= 2;	//set SOC1 channel select to ADCINA2
	//AdcRegs.ADCSOC3CTL.bit.CHSEL 	= 3;	//set SOC1 channel select to ADCINA3
	AdcRegs.ADCSOC0CTL.bit.TRIGSEL 	= 3;	//empieza con el desbordamiento del timer2
	//AdcRegs.ADCSOC1CTL.bit.TRIGSEL 	= 5;	//set SOC1 start trigger on EPWM1A, due to round-robin SOC0 converts first then SOC1
	//AdcRegs.ADCSOC2CTL.bit.TRIGSEL 	= 5;	//set SOC0 start trigger on EPWM1A, due to round-robin SOC0 converts first then SOC1
	//AdcRegs.ADCSOC3CTL.bit.TRIGSEL 	= 5;	//set SOC1 start trigger on EPWM1A, due to round-robin SOC0 converts first then SOC1
	AdcRegs.ADCSOC0CTL.bit.ACQPS 	= 6;	//set SOC0 S/H Window to 7 ADC Clock Cycles, (6 ACQPS plus 1)
	//AdcRegs.ADCSOC1CTL.bit.ACQPS 	= 6;	//set SOC1 S/H Window to 7 ADC Clock Cycles, (6 ACQPS plus 1)
	//AdcRegs.ADCSOC2CTL.bit.ACQPS 	= 6;	//set SOC0 S/H Window to 7 ADC Clock Cycles, (6 ACQPS plus 1)
	//AdcRegs.ADCSOC3CTL.bit.ACQPS 	= 6;	//set SOC1 S/H Window to 7 ADC Clock Cycles, (6 ACQPS plus 1)
	EDIS;

	// Assumes ePWM1 clock is already enabled in InitSysCtrl();
	//EPwm1Regs.ETSEL.bit.SOCAEN	= 1;		// Enable SOC on A group
	//EPwm1Regs.ETSEL.bit.SOCASEL	= ET_CTR_PRDZERO;		// Select SOC from from CPMA on upcount
	//EPwm1Regs.ETPS.bit.SOCAPRD 	= ET_1ST;		// Generate pulse on 1st event


}


