/*
 * pll_dq_funcionseno_monofasico.c
 *
 *  Created on: 2/3/2016
 *  Author: Carlos
 *  1) visualizar buffer_entrada y buffer_salida en q22 para comprobar el cdigo.
 *  2) cdigo ejecutado en FLASH.
 */

#include "DSP2802x_Device.h"     // DSP2802x Headerfile Include File
#include "pireg.h"
#include "GLOBAL_FUNCS.h"
#include "GLOBAL_VARS.h"
#include <stdio.h>
#include <math.h>
#include "IQmathLib.h"

extern void ServiceDog(void);
void cal_Vpico(void);

int i=0;
int i_90;
const _iq wff = _IQ(314.1592);	//valor mximo de salida del PI: 2*pi*50= 314.1592 rad/s
const _iq pi_2 = _IQ(1.57078);
//refe,fdb,err,kp,ki_ts"perio-muest",out maxima PI=2*pi*50=314.1592, out minima PI, salida,integral:
PIREG compensador = {_IQ(0), 0, 0, _IQ(2), _IQ(7.8E-5), _IQ(314.1592), _IQ(-314.1592), 0, 0,  pireg_compute};
_iq integrador =_IQ(0),  Vsin, Vsin_90, Va=_IQ(0), Vb=_IQ(0), Vpico=_IQ(0),  buffer[255], buffer_salida[255], buffer_entrada[255];
int BackTicker;

main ( ) {

DeviceInit();	// Inicializacin del dispositivo
InitDSP();		// Inicializacion de perifericos

//	BUCLE
	for(;;)
	{
		asm("          NOP");
				BackTicker++;
	}
}

//	INTERRUPCIN TIMER 2 CADA 78.125us
interrupt void TC0_Cpu_Timer2_isr(void) {

	Va=_IQsin(i*_IQ(0.02454369261));	//(360/256)(pi/180)=0.02454369261
	buffer[i]=Va;
	buffer_entrada[i]=Va;
	cal_Vpico();
	i_90 = i + 192;						//256-64=192
	i_90 = (i_90 > 255) ? (i_90 - 256) : (i_90); 					//operador ternario: variable=condicin?verdadero:falso
	Vb = buffer[i_90];
	//integrador:
	Vsin = _IQsin(integrador);
	Vsin_90 = _IQsin(integrador - pi_2);
	buffer_salida[i] = _IQcos(integrador);
	compensador.Fdb = _IQmpy(Va,Vsin) + _IQmpy(Vb,Vsin_90);
	compensador.compute(&compensador);
	integrador += _IQmpy((compensador.Out + wff),_IQ(7.8125E-5));	//7.8125E-5=periodo de muestreo(12800 hz)
	i = (i==255) ? 0 : (i+1);
	////////////////////////////////////////////
	CpuTimer2Regs.TCR.bit.TIF = 1;	// clear flag
	VTimer2++;
}

void cal_Vpico()
{
	Vpico=(Va>Vpico)?Va:Vpico;
}

// 	INTERRUPCIN TIMER 1 CADA 1ms
interrupt void TB0_Cpu_Timer1_isr(void){
	CpuTimer1Regs.TCR.bit.TIF = 1;	// Borrar Flag
	VTimer1++;
}

// 	INTERRUPCIN TIMER 0 CADA 100ms
interrupt void TA0_Cpu_Timer0_isr(void){
	VTimer0++;
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;
}

void InitDSP(){
	// Deshabilitamos las interrupciones de la CPU
   	DINT;
	// Deshabilitamos las interrupciones de la CPU y borramos los flags
   	IER = 0x0000;
   	IFR = 0x0000;
	InitTimers();	// Inicializacin de los temporizadores
	//InitADC();	// Inicializacin del conversor analgico - digital
	//InitPWM();	// Inicializacion del mdulo PWM 1 y 2
	//InitSci();	// Inicializamos el modulo SCI
	InitInt();	// Inicializacin de las interrupciones
}

void InitTimers (void){
	EALLOW;
		SysCtrlRegs.PCLKCR3.bit.CPUTIMER0ENCLK = 1; // Habilita el reloj del  Timer-0 de la CPU
   		SysCtrlRegs.PCLKCR3.bit.CPUTIMER1ENCLK = 1; // Habilita el reloj del  Timer-1 de la CPU
   		SysCtrlRegs.PCLKCR3.bit.CPUTIMER2ENCLK = 1; // Habilita el reloj del  Timer-2 de la CPU
   	EDIS;
	// Asignamos los manejadores de interrupcin a los timers
	EALLOW;
	   	PieVectTable.TINT0 = &TA0_Cpu_Timer0_isr;
		PieVectTable.TINT1 = &TB0_Cpu_Timer1_isr;
		PieVectTable.TINT2 = &TC0_Cpu_Timer2_isr;
	EDIS;
	// Inicializamos los perifericos de los temporizadores
   	InitCpuTimers();   // For this example, only initialize the Cpu Timers
	// Configuramos los temporiuzadores
	ConfigCpuTimer(&CpuTimer0, 60, 100000);		//100ms
	ConfigCpuTimer(&CpuTimer1, 60, 1000);		//1ms
	ConfigCpuTimer(&CpuTimer2, 60, 78.125);		//desborda cada 78.125 us,parametro1:frecuen cpu,parametro2:desbor(us)
  	CpuTimer0Regs.TCR.all = 0x4001; // Habilitado interrupcin por timmer0
   	CpuTimer1Regs.TCR.all = 0x4001; // Habilitado interrupcin por timmer1
   	CpuTimer2Regs.TCR.all = 0x4001; // Habilitado interrupcin por timmer2
	/*************************************************************************************/
	VTimer0 = 0;	// Contador del Evento del Timer-0
	VTimer1 = 0; 	// Contador del Evento del Timer-1
	VTimer2 = 0; 	// Contador del Evento del Timer-2
}

void InitInt(void){
	// Configuracin de la interrupcin externa
	/*EALLOW;
		GpioCtrlRegs.GPAMUX2.bit.GPIO18 = 0;         // GPIO-18
		GpioCtrlRegs.GPADIR.bit.GPIO18 = 0;
		GpioCtrlRegs.GPAQSEL2.bit.GPIO18 = 2;
		GpioCtrlRegs.GPAPUD.bit.GPIO18 = 0;
		GpioCtrlRegs.GPACTRL.bit.QUALPRD2 = 0x2F;
	  	GpioCtrlRegs.GPAMUX1.bit.GPIO12 = 0;         // GPIO-12
	   	GpioCtrlRegs.GPADIR.bit.GPIO12 = 0;
	   	GpioCtrlRegs.GPAQSEL1.bit.GPIO12 = 2;
	   	GpioCtrlRegs.GPAPUD.bit.GPIO12 = 1; 		 // Se deshabilita la resistencia de PU
	   	GpioCtrlRegs.GPACTRL.bit.QUALPRD1 = 0x2F;
	   	GpioIntRegs.GPIOXINT1SEL.bit.GPIOSEL = 18;   // XINT1 es GPIO18
		//GpioIntRegs.GPIOXINT1SEL.bit.GPIOSEL = 12; // XINT1 es GPIO12
	EDIS;
	XIntruptRegs.XINT1CR.bit.POLARITY = 1;      	// Flanco SUBIDA de XINT1
	XIntruptRegs.XINT1CR.bit.ENABLE = 1;        	// Enable Xint1
	EALLOW;
	PieVectTable.XINT1 = &xint1_isr;				// Interrupcion XINT1
	EDIS;*/
	// Enable Peripheral, global Ints and higher priority real-time debug events:
   	IER |= (M_INT1|M_INT2);
   	IER |= (M_INT3|M_INT4);
   	IER |= M_INT8;
   	IER |= M_INT9; 									// Esta deja Bloqueado al HW...
	// Activar interrupcin XINT1
	//PieCtrlRegs.PIEIER1.bit.INTx4 = 1;   // XINT1
	// Activar interrupcin sci fifo rx
	//PieCtrlRegs.PIEIER9.bit.INTx1 = 1;   // RX SCIA
	// Activar interrupciones ePWM
	//PieCtrlRegs.PIEIER3.bit.INTx1 = 1;	//	ePWM1
	//PieCtrlRegs.PIEIER3.bit.INTx2 = 1;	//	ePWM2
	// Activar Interrupciones Timers-CPU
	PieCtrlRegs.PIEIER1.bit.INTx7 = 1; 	//	T0
   	IER |= (M_INT13 |M_INT14) ;			//	T1 y T2
   	//////////////////////////////////////////////////////////
	// Enable the PIE
    PieCtrlRegs.PIECTRL.bit.ENPIE = 1;
	// Enables PIE to drive a pulse into the CPU
	PieCtrlRegs.PIEACK.all = 0xFFFF;
	// Enable Interrupts at the CPU level
    EINT;   // Enable Global interrupt INTM
	ERTM;   // Enable Global realtime interrupt DBGM
	//////////////////////////////////////////////////////

}


